
#include <libgnomevfs/gnome-vfs.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int convert_to_backslash(char *dest,const char *src) {
  int i = 0, count_slash = 0;
  while (src[i] != '\0') {
    if ((src[i] == '/') && (src[i+1] != '\0')) {
      count_slash++;
    } else if ((src[i] == '/') && (src[i+1] == '\0')) { /* String ends with / */
      *dest++ = '\\';  
    } else {
      if (count_slash > 0) {
        *dest++ = '\\';
				*dest++ = src[i];
			}  else 
				*dest++ = src[i];
	    
			count_slash = 0;
	  }
    ++i;
  }
	*dest = '\0';
	return i;
}

void remove_double_slash(char *path) {
  char *pos = path;
  while (*path != '\0') {
		if (*path == '/' && *(path+1) == '/') {
	    path++;
	    continue;
		}
  	*pos++ = *path++;
  }
  *pos = '\0';
}

int slash2backslash(char *dest,const char *src) {
	int i = 0;

  remove_double_slash((char*)src);
  while (src[i] != 0) {
		if (src[i] == '/') dest[i++] = '\\'; else dest[i] = src[i++];
  }
  dest[i] = 0;
  return i;
}

void print_uri_info(GnomeVFSURI *u)
{
	g_print("  to_string                %s\n", 
		gnome_vfs_uri_to_string(u, GNOME_VFS_URI_HIDE_NONE));
	g_print("  get_path                 %s\n", 
		gnome_vfs_uri_get_path(u));
	g_print("  get_fragment_identifier  %s\n", 
		gnome_vfs_uri_get_fragment_identifier(u));
	g_print("  extract_dirname          %s\n", 
		gnome_vfs_uri_extract_dirname(u));
	g_print("  extract_short_name       %s\n", 
		gnome_vfs_uri_extract_short_name(u));
	g_print("  extract_short_path_name  %s\n", 
		gnome_vfs_uri_extract_short_path_name(u));
	g_print("  get_toplevel             %s\n", 
		gnome_vfs_uri_get_toplevel(u));

}

int
main (int argc, char **argv)
{
  gint i;
	GnomeVFSURI *uri;
	gchar strbuf[100];
	gchar *tests[10] = { 
		"file:///",
		"iriver:///My",
		"iriver:///My/",
		"iriver:",
		"iriver:///",
		"iriver:///My/pippo.mp3",
		"iriver:///My/a/pippo.mp3",
		"iriver:///My/a/b/pippo.mp3",
		"iriver:///My/a/b/",
		"iriver:///pippo.mp3" };

	//gnome_vfs_init();
	
	for (i = 0; i < 10; i++) {
		//uri = gnome_vfs_uri_new (tests[i]);
		g_print("test %d - %s\n", i, tests[i]);
		/*print_uri_info(uri);
			gnome_vfs_uri_unref(uri);*/
		slash2backslash(strbuf,g_strdup(tests[i]));
		fprintf(stderr, "1 %s\n", strbuf);
		convert_to_backslash(strbuf, tests[i]);
		fprintf(stderr, "2 %s\n", strbuf);

	}

		 	

	return 0;
}
