#include <libgnomevfs/gnome-vfs.h>

#define DEBUG
#ifdef DEBUG
#define D(x...) g_message (x)
#else
#define D(x...) 
#endif


int
main (int argc, char *argv[])
{
	GList *dlist = NULL;
	gchar *old, *new;
	GnomeVFSResult result;

	gnome_vfs_init ();

	if (argc == 3) {
		old = argv[1];
		new = argv[2];
	} else {
		g_print ("should be %s <old> <new>\n", argv[0]);
		g_print ("uses gnome_vfs_move, hence uri's have to be on the same FS\n");
		exit (0);
	}

	// force_replace set to TRUE
	result = gnome_vfs_move (old, new, TRUE);

	if (result != GNOME_VFS_OK) {
		g_print ("Error: %s\n",
			 gnome_vfs_result_to_string (result));
		exit (0);
	}

	gnome_vfs_shutdown ();
	return 0;
}
